#property copyright "Copyright  2006, AW Traders."
#property link      "http://www.fxtraders.biz"

#include <stdlib.mqh>

extern double Preset_SL = 400.0;//40.0
extern double Preset_TP = 30.0;//80.0
extern int Target1 = 5;
extern int LockProfit1 = 3;
extern int Target2 = 10;
extern int LockProfit2 = 6;
extern int Target3 = 15;
extern int LockProfit3 = 11;
extern int Target4 = 20;
extern int LockProfit4 = 16;
extern int Target5 = 25;
extern int LockProfit5 = 22;
bool gi_132 = TRUE;
bool gi_136 = FALSE;
bool gi_140 = FALSE;
bool gi_144 = FALSE;
bool gi_148 = FALSE;
double gd_152;
string gs_160 = "V0_2_3";
int gi_168 = 10;
double gd_172 = 4.0;
double gd_180 = 25.0;
string gs_188 = "OrderReliable fname unset";
int gi_unused_196 = 0/* NO_ERROR */;

int init() {
   gd_152 = MarketInfo(Symbol(), MODE_POINT);
   int l_digits_0 = MarketInfo(Symbol(), MODE_DIGITS);
   int li_4 = StringFind(Symbol(), "JPY", 0);
   if (li_4 == -1) {
      switch (l_digits_0) {
      case 4:
         gd_152 = Point;
         return (gd_152);
      case 5:
         gd_152 = 10.0 * Point;
         return (gd_152);
      }
   }
   if (li_4 == 3) {
      gd_152 = 0.01;
      return (gd_152);
   }
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int l_ord_total_0;
   if (Bars < 100) {
      Print("bars less than 100");
      return (0);
   }
   if (LockProfit1 > Target1 || LockProfit2 > Target2 || LockProfit3 > Target3 || LockProfit4 > Target4 || LockProfit5 > Target5) Comment("Wrong setting of Target or Stop Loss !");
   if (Target1 > 0 && subOrdersTotal() > 0 && gi_132 || gi_136 || gi_140 || gi_144 || gi_148) {
      l_ord_total_0 = OrdersTotal();
      for (int l_pos_4 = 0; l_pos_4 < OrdersTotal(); l_pos_4++) {
         OrderSelect(l_pos_4, SELECT_BY_POS, MODE_TRADES);
         if (OrderStopLoss() == 0.0 && OrderTakeProfit() == 0.0) {
            if (OrderType() == OP_BUY) OrderModifyReliableSymbol(Symbol(), OrderTicket(), Ask, Ask - Preset_SL * gd_152, Ask + Preset_TP * gd_152, 0, -1);
            if (OrderType() == OP_SELL) OrderModifyReliableSymbol(Symbol(), OrderTicket(), Bid, Bid + Preset_SL * gd_152, Bid - Preset_TP * gd_152, 0, -1);
         }
         if (OrderType() <= OP_SELL && OrderSymbol() == Symbol()) {
            if (OrderType() == OP_BUY) {
               if (gi_132) {
                  if (Bid - OrderOpenPrice() >= gd_152 * Target1 && OrderStopLoss() < OrderOpenPrice() + gd_152 * LockProfit1) {
                     OrderModifyReliableSymbol(Symbol(), OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + gd_152 * LockProfit1, OrderTakeProfit(), 0, 32768);
                     if (Target2 > 0) gi_136 = TRUE;
                     return (0);
                  }
               }
               if (gi_136) {
                  if (Bid - OrderOpenPrice() >= gd_152 * Target2 && OrderStopLoss() < OrderOpenPrice() + gd_152 * LockProfit2) {
                     OrderModifyReliableSymbol(Symbol(), OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + gd_152 * LockProfit2, OrderTakeProfit(), 0, 32768);
                     if (Target3 > 0) gi_140 = TRUE;
                     return (0);
                  }
               }
               if (gi_140) {
                  if (Bid - OrderOpenPrice() >= gd_152 * Target3 && OrderStopLoss() < OrderOpenPrice() + gd_152 * LockProfit3) {
                     OrderModifyReliableSymbol(Symbol(), OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + gd_152 * LockProfit3, OrderTakeProfit(), 0, 32768);
                     if (Target4 > 0) gi_144 = TRUE;
                     return (0);
                  }
               }
               if (gi_144) {
                  if (Bid - OrderOpenPrice() >= gd_152 * Target4 && OrderStopLoss() < OrderOpenPrice() + gd_152 * LockProfit4) {
                     OrderModifyReliableSymbol(Symbol(), OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + gd_152 * LockProfit4, OrderTakeProfit(), 0, 32768);
                     if (Target5 > 0) gi_148 = TRUE;
                     return (0);
                  }
               }
               if (gi_148) {
                  if (Bid - OrderOpenPrice() >= gd_152 * Target5 && OrderStopLoss() < OrderOpenPrice() + gd_152 * LockProfit5) {
                     OrderModifyReliableSymbol(Symbol(), OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + gd_152 * LockProfit5, OrderTakeProfit(), 0, 32768);
                     return (0);
                  }
               }
            }
            if (OrderType() == OP_SELL) {
               if (gi_132) {
                  if (OrderOpenPrice() - Ask >= gd_152 * Target1 && OrderStopLoss() > OrderOpenPrice() - gd_152 * LockProfit1 || OrderStopLoss() == 0.0) {
                     OrderModifyReliableSymbol(Symbol(), OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - gd_152 * LockProfit1, OrderTakeProfit(), 0, 32768);
                     if (Target2 > 0) gi_136 = TRUE;
                     return (0);
                  }
               }
               if (gi_136) {
                  if (OrderOpenPrice() - Ask >= gd_152 * Target2 && OrderStopLoss() > OrderOpenPrice() - gd_152 * LockProfit2) {
                     OrderModifyReliableSymbol(Symbol(), OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - gd_152 * LockProfit2, OrderTakeProfit(), 0, 32768);
                     if (Target3 > 0) gi_140 = TRUE;
                     return (0);
                  }
               }
               if (gi_140) {
                  if (OrderOpenPrice() - Ask >= gd_152 * Target3 && OrderStopLoss() > OrderOpenPrice() - gd_152 * LockProfit3) {
                     OrderModifyReliableSymbol(Symbol(), OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - gd_152 * LockProfit3, OrderTakeProfit(), 0, 32768);
                     if (Target4 > 0) gi_144 = TRUE;
                     return (0);
                  }
               }
               if (gi_144) {
                  if (OrderOpenPrice() - Ask >= gd_152 * Target4 && OrderStopLoss() > OrderOpenPrice() - gd_152 * LockProfit4) {
                     OrderModifyReliableSymbol(Symbol(), OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - gd_152 * LockProfit4, OrderTakeProfit(), 0, 32768);
                     if (Target5 > 0) gi_148 = TRUE;
                     return (0);
                  }
               }
               if (gi_148) {
                  if (OrderOpenPrice() - Ask >= gd_152 * Target5 && OrderStopLoss() > OrderOpenPrice() - gd_152 * LockProfit5) {
                     OrderModifyReliableSymbol(Symbol(), OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - gd_152 * LockProfit5, OrderTakeProfit(), 0, 32768);
                     return (0);
                  }
               }
            }
         }
      }
   }
   return (0);
}

int subOrdersTotal() {
   int li_ret_0;
   int l_ord_total_4 = OrdersTotal();
   for (int l_pos_8 = 0; l_pos_8 < l_ord_total_4; l_pos_8++) {
      OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() <= OP_SELL && OrderSymbol() == Symbol()) li_ret_0++;
   }
   return (li_ret_0);
}

int OrderModifyReliable(int a_ticket_0, double a_price_4, double a_price_12, double a_price_20, int a_datetime_28, color a_color_32 = -1) {
   string ls_40;
   gs_188 = "OrderModifyReliable";
   OrderReliablePrint(" attempted modify of #" + a_ticket_0 + " price:" + a_price_4 + " sl:" + a_price_12 + " tp:" + a_price_20);
   if (!IsConnected()) {
      OrderReliablePrint("error: IsConnected() == false");
      gi_unused_196 = 6;
      return (0);
   }
   if (IsStopped()) {
      OrderReliablePrint("error: IsStopped() == true");
      return (0);
   }
   for (int l_count_36 = 0; !IsTradeAllowed() && l_count_36 < gi_168; l_count_36++) OrderReliable_SleepRandomTime(gd_172, gd_180);
   if (!IsTradeAllowed()) {
      OrderReliablePrint("error: no operation possible because IsTradeAllowed()==false, even after retries.");
      gi_unused_196 = 146;
      return (0);
   }
   int l_error_52 = GetLastError();
   l_error_52 = 0;
   gi_unused_196 = 0;
   bool li_56 = FALSE;
   l_count_36 = 0;
   bool l_bool_60 = FALSE;
   while (!li_56) {
      if (IsTradeAllowed()) {
         l_bool_60 = OrderModify(a_ticket_0, a_price_4, a_price_12, a_price_20, a_datetime_28, a_color_32);
         l_error_52 = GetLastError();
         gi_unused_196 = l_error_52;
      } else l_count_36++;
      if (l_bool_60 == TRUE) li_56 = TRUE;
      switch (l_error_52) {
      case 0/* NO_ERROR */:
         li_56 = TRUE;
         break;
      case 1/* NO_RESULT */:
         li_56 = TRUE;
         break;
      case 4/* SERVER_BUSY */:
      case 6/* NO_CONNECTION */:
      case 129/* INVALID_PRICE */:
      case 136/* OFF_QUOTES */:
      case 137/* BROKER_BUSY */:
      case 146/* TRADE_CONTEXT_BUSY */:
      case 128/* TRADE_TIMEOUT */:
         l_count_36++;
         break;
      case 135/* PRICE_CHANGED */:
      case 138/* REQUOTE */:
         RefreshRates();
         continue;
         break;
      default:
         li_56 = TRUE;
      }
      if (l_count_36 > gi_168) li_56 = TRUE;
      if (!li_56) {
         OrderReliablePrint("retryable error (" + l_count_36 + "/" + gi_168 + "): " + OrderReliableErrTxt(l_error_52));
         OrderReliable_SleepRandomTime(gd_172, gd_180);
         RefreshRates();
      }
      if (li_56) {
         if (l_error_52 != 0/* NO_ERROR */ && l_error_52 != 1/* NO_RESULT */) OrderReliablePrint("non-retryable error: " + OrderReliableErrTxt(l_error_52));
         if (l_count_36 > gi_168) OrderReliablePrint("retry attempts maxed at " + gi_168);
      }
   }
   if (l_bool_60 == TRUE || l_error_52 == 0/* NO_ERROR */) {
      OrderReliablePrint("apparently successful modification order, updated trade details follow.");
      OrderSelect(a_ticket_0, SELECT_BY_TICKET, MODE_TRADES);
      OrderPrint();
      return (1);
   }
   if (l_error_52 == 1/* NO_RESULT */) {
      OrderReliablePrint("Server reported modify order did not actually change parameters.");
      OrderReliablePrint("redundant modification: " + a_ticket_0 + " " + ls_40 + "@" + a_price_4 + " tp@" + a_price_20 + " sl@" + a_price_12);
      OrderReliablePrint("Suggest modifying code logic to avoid.");
      return (1);
   }
   OrderReliablePrint("failed to execute modify after " + l_count_36 + " retries");
   OrderReliablePrint("failed modification: " + a_ticket_0 + " " + ls_40 + "@" + a_price_4 + " tp@" + a_price_20 + " sl@" + a_price_12);
   OrderReliablePrint("last error: " + OrderReliableErrTxt(l_error_52));
   return (0);
}

void OrderModifyReliableSymbol(string a_symbol_0, int ai_8, double ad_12, double ad_20, double ad_28, int ai_36, int ai_40 = -1) {
   int l_digits_44 = MarketInfo(a_symbol_0, MODE_DIGITS);
   if (l_digits_44 > 0) {
      ad_12 = NormalizeDouble(ad_12, l_digits_44);
      ad_20 = NormalizeDouble(ad_20, l_digits_44);
      ad_28 = NormalizeDouble(ad_28, l_digits_44);
   }
   if (ad_20 != 0.0) OrderReliable_EnsureValidStop(a_symbol_0, ad_12, ad_20);
   OrderModifyReliable(ai_8, ad_12, ad_20, ad_28, ai_36, ai_40);
}

string OrderReliableErrTxt(int ai_0) {
   return ("" + ai_0 + ":" + ErrorDescription(ai_0));
}

void OrderReliablePrint(string as_0) {
   Print(gs_188 + " " + gs_160 + ":" + as_0);
}

void OrderReliable_EnsureValidStop(string a_symbol_0, double ad_8, double &ad_16) {
   double ld_24;
   if (ad_16 != 0.0) {
      ld_24 = MarketInfo(a_symbol_0, MODE_STOPLEVEL) * MarketInfo(a_symbol_0, MODE_POINT);
      if (MathAbs(ad_8 - ad_16) <= ld_24) {
         if (ad_8 > ad_16) ad_16 = ad_8 - ld_24;
         else {
            if (ad_8 < ad_16) ad_16 = ad_8 + ld_24;
            else OrderReliablePrint("EnsureValidStop: error, passed in price == sl, cannot adjust");
         }
         ad_16 = NormalizeDouble(ad_16, MarketInfo(a_symbol_0, MODE_DIGITS));
      }
   }
}

void OrderReliable_SleepRandomTime(double ad_0, double ad_8) {
   double ld_16;
   int li_24;
   double ld_28;
   if (IsTesting() == 0) {
      ld_16 = MathCeil(ad_0 / 0.1);
      if (ld_16 > 0.0) {
         li_24 = MathRound(ad_8 / 0.1);
         ld_28 = 1.0 - 1.0 / ld_16;
         Sleep(1000);
         for (int l_count_36 = 0; l_count_36 < li_24; l_count_36++) {
            if (MathRand() > 32768.0 * ld_28) break;
            Sleep(1000);
         }
      }
   }
}